# Anonbot
A bot for West Side students to submit confessions and announce anonymously!

# Rules
We want Anonbot to be a fun experience for everyone, so generally we allow you to post whatever you want. However, there are a few things there are a few exceptions that you need to be aware of before posting. Breaking these rules will get your post deleted, and repeated offenses will get you IPbanned.

**1. Don't post anything that goes against Instagram's terms of use.** Use common sense here. Don't post anything that discriminates against a group of people (e.g. racist, sexist, homophobic, etc.), anything that can cause people harm (e.g. telling someone to kill themself), or anything illegal (e.g. killing prominent figures and politicians). Essentially, don't post anything that can get reported and taken down by Instagram, and please don't post anything that will get the police called.

**2. Don't bully anyone.** Making lighthearted fun of people is part of what makes Anonbot fun. But if it crosses the line into bullying, it crosses over into rule 1. Don't deliberately put any one person or group down. **This includes making posts that shit-talk other people.** You should be able to understand the difference between making jokes and bullying someone.

**3. Don't spread false rumors.** This kind of goes along with rule 2. I wanted to give this point its own separate rule because I think it needs to be explicitly stated that this is not okay. Anonbot is not a place where you go to spread rumors about students at our school that could get them in trouble, both with other students and with the school administration. Imagine having your reputation ruined by an Instagram bot. That's incredibly stupid. Don't be a part of that.

**4. Don't spam.** This is one of the most annoying rules to have to enforce. *Don't spam.* Spam should be self-explanatory. Spamming will likely get you IPbanned quicker than anything else here.

**5. Don't excessively shitpost.** This kind of goes along with rule 4. Shitposting makes up a large part of Anonbot's posts, so it's okay to shitpost. It's part of what makes Anonbot fun. But please don't spam the Anonbot feed with stupid things like one-word posts or all-emoji posts. That's just annoying. Posting this kind of stuff probably won't get you banned (unless it crosses over to excessive spam territory), but it will probably get your post deleted. Just don't do it. You're not funny.

**Reporting:** If you see a post that you feel is breaking one or more of these rules and should be removed, please don't report it to Instagram! That will put Anonbot as a whole at risk of being deleted. Instead, please DM the account and we will take it down.

---

In order to enforce these rules and ban people who are repeatedly breaking rules, Anonbot temporarily logs *IP hashes* of everyone who posts something. See *What are IP hashes and can I be tracked with them?* (short answer: no) and *I've heard of something like this before where the creators released personal info anyway. How can I be sure this is not the case with Anonbot?* in the **FAQ** section for more info.

Anonbot has moderation tools that a group of moderators use to delete posts, make mod posts (posts with a red background), and IPban people who post things that warrant a ban. Please don't be the guy who turns on their VPN to keep spamming after we've already banned you. There are 8 of us. We will keep banning you until you give up. You have better things to do. Don't be an asshole.

Finally, if you've been banned and you feel your ban is unjust, or you want to try to be unbanned after you've done something wrong, please don't be afraid to DM the Instagram account. We really don't care who you are; we just want to keep Anonbot safe and spam-free. So if you just talk to us, we will probably be more than happy to unban you.

# FAQ

**Q: What are IP hashes and can I be tracked with them?**\
A: Every time you post, Anonbot retrives your IP and runs it through a SHA256 hashing algorithm. This algorithm encrypts your IP by converting it to a 64-character string of seemingly random characters. It is then stored in a database for a short period of time. It is impossible to reverse a hash function, which means it is impossible for us to see your IP. You are completely anonymous when you use Anonbot; **you can not be tracked at all.** [Read more about hashes and how they are used in cryptography](https://en.wikipedia.org/wiki/SHA-2)

**Q: Why do you log IP hashes?**\
A: We want to make sure Anonbot isn't ruined by spammers and trolls, so we store IP hashes for a short period of time in order to keep track of recent posts. If we find repeated violations of the rules above from one IP address, that person will be banned from using Anonbot.

**Q: I've heard of something like this before where the creators released personal info anyway. How can I be sure this is not the case with Anonbot?**\
A: Part of Anonbot's dedication to open-source code is to alleviate these kinds of worries. Anonbot does not store any personal information. We cannot use your IP hash to track you or find your personal information (see *What are IP hashes and can I be tracked with them?*). Your name, Instagram account, etc. are not stored. **Even if we wanted to, Anonbot is made in a way that does not allow us to find who submitted a post.** If you would like to verify this claim, you can look at the code for Anonbot, which is completely open-source (click on "View code on GitHub" at the bottom of the webpage and find the *server.js* file). Please DM if you'd like to be walked through the code.

**Q: I've just seen a post on Anonbot that I believe is inappropriate. How can I get it removed?**\
A: If you see a post that you believe to be inappropriate, please do not report it to Instagram (this puts Anonbot as a whole at risk!). Instead, please DM **@anonbot.wl** to contact a moderator for deletion. Doing this will help moderate Anonbot and keep track of those who break the rules without risking the deletion of Anonbot as a whole by Instagram.

**Q: Is the school administration okay with this?**\
A: Anonbot was first created on June 20th, 2018, and v2 was first implemented on July 14th, 2018. Because Anonbot was created during the summer, the school administration does not know about it (see the dislcaimers section). We do not believe Anonbot is breaking any school rules, but if any conflicts arise in the future, we will comply fully.

# Disclaimers
For moderation purposes, every submission, as well as a hash of the IP address of the submitter, is logged for 10 days. We do not use the hash of your IPs for any purpose other than to ban those who break the rules repeatedly. Furthermore, the hashes are irreversible and cannot be tracked back to the original IP. This should not affect you as long as you use Anonbot properly.

Anonbot is not endorsed by or affiliated with the West Lafayette High School in any way. This is simply a small and fun project created by West Side students.

If you believe a post should be taken down or have any questions/concerns about Anonbot, please email matthew@matthewstanciu.me or DM @anonbot.wl.

---

[View on Glitch](https://glitch.com/edit/#!/anonbotwl?path=README.md:1:0)
